/*
 * initialization.h
 *
 * Created: 21/03/2014 10:15:46
 *  Author: marcadella
 */ 

// This file implements the functions needed to initialize clocks, GPIOs, usart port, RTC, and T/Cs

#ifndef AUX_H
#define AUX_H

#include "intc.h"
#include "board.h"
#include "pm_uc3c.h"
#include "power_clocks_lib.h"


/**
 * \brief A method configuring the optimized when the clock is 12 MHZ
 * 
 * \param param: Clock parameters
 * 
 * \return int
 */
int pm_configure_clocks_optimized(pcl_freq_param_t *param);


/**
 * \brief Clock config
 * 
 * \param 
 * 
 * \return void
 */
void init_sys_clocks(void);


// ********************* LEDS config

#define LED_G			(AVR32_PIN_PC04)
#define LED_R			(AVR32_PIN_PC05)
#define LED0_GPIO		(AVR32_PIN_PA08)
#define LED1_GPIO		(AVR32_PIN_PD23)
#define LED2_GPIO		(AVR32_PIN_PC13)
#define LED3_GPIO		(AVR32_PIN_PD22)


#endif // AUX_H