/*
 * freertos_hooks.c
 *
 * Created: 18.03.2016 18:47:57
 *  Author: Normann
 */ 

#include "middleware/freertos_hooks.h"

/**
 * \brief Handler for Sytem Tick interrupt.
 */
void SysTick_Handler(void){
	xPortSysTickHandler();
}

/**
 * \brief Called if stack overflow during execution
 */
extern void vApplicationStackOverflowHook(xTaskHandle *pxTask, signed char *pcTaskName){
	printf("stack overflow %x %s\r\n", pxTask, (portCHAR *)pcTaskName);
	/* If the parameters have been corrupted then inspect pxCurrentTCB to
	 * identify which task has overflowed its stack.
	 */
	for (;;) {
	}
}

/**
 * \brief This function is called by FreeRTOS idle task
 */
extern void vApplicationIdleHook(void){
}

/**
 * \brief This function is called by FreeRTOS each tick
 */
extern void vApplicationTickHook(void){
}

extern void vApplicationMallocFailedHook(void){
	/* Called if a call to pvPortMalloc() fails because there is insufficient
	free memory available in the FreeRTOS heap.  pvPortMalloc() is called
	internally by FreeRTOS API functions that create tasks, queues, software
	timers, and semaphores.  The size of the FreeRTOS heap is set by the
	configTOTAL_HEAP_SIZE configuration constant in FreeRTOSConfig.h. */

	/* Force an assert. */
	//configASSERT( ( volatile void * ) NULL );
}