/*
 * task_aux.c
 *
 * Created: 18.03.2016 19:03:46
 *  Author: Normann
 */ 

#include <asf.h>
#include "services/helper_tasks.h"

/**
 * \brief This task, when activated, send every ten seconds on debug UART
 * the whole report of free heap and total tasks status
 */
void task_monitor(void *pvParameters){
	static portCHAR szList[256];
	UNUSED(pvParameters);

	for (;;) {
		printf("--- task ## %u", (unsigned int)uxTaskGetNumberOfTasks());
		printf("\r\n");
		vTaskList((signed portCHAR *)szList);
		printf(szList);
		vTaskDelay(2000);
	}
}

/**
 * \brief This task, when activated, make LED blink at a fixed rate
 */
void task_led(void *pvParameters){
	UNUSED(pvParameters);
	for (;;) {
		LED_Toggle(LED0);
		vTaskDelay(1000);
	}
}

void helper_tasks_init(void){
	/* Create task to monitor processor activity */
	if (xTaskCreate(task_monitor, "Monitor", TASK_MONITOR_STACK_SIZE, NULL, TASK_MONITOR_STACK_PRIORITY, NULL) != pdPASS) {
		printf("Failed to create Monitor task\r\n");
	}

	/* Create task to make led blink */
	if (xTaskCreate(task_led, "Led", TASK_LED_STACK_SIZE, NULL,	TASK_LED_STACK_PRIORITY, NULL) != pdPASS) {
		printf("Failed to create test led task\r\n");
	}
}