/*
 * logger.c
 *
 * Created: 11.03.2016 21:24:31
 *  Author: Admin
 */ 

#include <asf.h>
#include <csp/csp.h>
#include <csp/csp_nuts.h>
#include <csp/arch/csp_thread.h>
#include "services/logger.h"

CSP_DEFINE_TASK(task_logger) {

	/* Create socket without any socket options */
	csp_socket_t *sock = csp_socket(CSP_SO_NONE);

	/* Bind LOGGER_RX_PORT to socket */
	csp_bind(sock, LOGGER_RX_PORT);

	/* Create 10 connections backlog queue */
	csp_listen(sock, 10);

	/* Pointer to current connection and packet */
	csp_conn_t *conn;
	csp_packet_t *packet;

	/* Process incoming connections */
	while (1) {

		/* Wait for connection, 10000 ms timeout */
		if ((conn = csp_accept(sock, 10000)) == NULL)
		continue;

		/* Read packets. Timout is 100 ms */
		while ((packet = csp_read(conn, 100)) != NULL) {
			switch (csp_conn_dport(conn)) {
				case LOGGER_RX_PORT:
				/* Process packet here */
				printf("Packet received on LOGGER_RX_PORT: %s\r\n", (char *) packet->data);
				csp_buffer_free(packet);
				break;

				default:
				/* Let the service handler reply pings, buffer use, etc. */
				csp_service_handler(conn, packet);
				break;
			}
		}

		/* Close current connection, and handle next */
		csp_close(conn);
	}

	return CSP_TASK_RETURN;
}