/*
 * tickless_idle.h
 *
 * Created: 18.03.2016 15:30:26
 *  Author: Normann
 */ 


#ifndef TICKLESS_IDLE_H_
#define TICKLESS_IDLE_H_

/* Flag set from the tick interrupt to allow the sleep processing to know if
sleep mode was exited because of an AST interrupt or a different interrupt. */
static volatile uint32_t ulTickFlag = pdFALSE;

/* Variable to keep user alarm value. */
static volatile uint32_t ulUserAlarmValue = 0;

#define MAXIMUM_POSSIBLE_SLEEP_TIME		(UINT32_MAX/CONF_RTT_PRESCALER_VAL)
#define RTT_TICKS_PER_SEC				(32768/CONF_RTT_PRESCALER_VAL)
#define RTT_TICKS_PER_MILLI_SEC			RTT_TICKS_PER_SEC/1000
void tickless_idle_configure(void);

/* The configPRE_SLEEP_PROCESSING() and configPOST_SLEEP_PROCESSING() macros
allow the application writer to add additional code before and after the MCU is
placed into the low power state respectively.  The empty implementations
provided in this demo can be extended to save even more power. */
void vPreSleepProcessing( unsigned long xExpectedIdleTime );
void vPostSleepProcessing( unsigned long xExpectedIdleTime );

#endif /* TICKLESS_IDLE_H_ */